import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class PerfectPlayer here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class PerfectPlayer extends ComputerPlayer
{   
    public void startTurn()
    {
        Player tgt = pickTarget();
        
        int deg = aimFor(tgt.getX());
        System.out.println("Firing at angle: " + deg);
        fire(Math.toRadians(deg), 1.0);
        
    }
    
    private int aimFor(int targetX)
    {
        int incDegrees;
        int degLowest;
        if (targetX < getX())
        {
            //Shooting left:
            incDegrees = -1;
            degLowest = -180 + ProjectileWorld.LOWEST_ANGLE;
        }
        else
        {
            //Shooting right:
            incDegrees = +1;
            degLowest = -ProjectileWorld.LOWEST_ANGLE;
        }
        
        for (int degrees = -90; degrees != degLowest; degrees += incDegrees)
        {
            double radianAngle = Math.toRadians(degrees);
            double vx = Player.getVelX(radianAngle, 1.0);
            double vy = Player.getVelY(radianAngle, 1.0);
        
            double impactTime = 2.0 * (vy / ProjectileWorld.GRAVITY) - 1;
            double impactX = getX() + impactTime * vx;
            
            System.out.println("Aim: " + targetX + " Angle: " + degrees + " vx: " + vx + " vy: " + vy + " t: " + impactTime + " ix: " + impactX);
            
            if ((targetX < getX() && impactX <= targetX)
                || (targetX > getX() && impactX >= targetX))
            {
                return degrees;
            }
        }
        return degLowest;
    }
}
