import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.HashMap;

/**
 * Write a description of class MenuWorld here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class MenuWorld extends World
{
    private HashMap<String, Player> options = new HashMap<String, Player>();

    /**
     * Constructor for objects of class MenuWorld.
     * 
     */
    public MenuWorld()
    {    
        // Create a new world with 600x400 cells with a cell size of 1x1 pixels.
        super(800, 600, 1); 
        
        getBackground().setColor(new java.awt.Color(0.8f, 0.95f, 1.0f, 1.0f));
        getBackground().fill();
        
        GreenfootImage headerText = new GreenfootImage("Select Opponent", 50, java.awt.Color.WHITE, null);
        getBackground().drawImage(headerText, (800 - headerText.getWidth()) / 2, 50);
        GreenfootImage monkeyImg = new GreenfootImage("monkey.png");
        getBackground().drawImage(monkeyImg, 400 - monkeyImg.getWidth() / 2, 120);
        
        addOption("Human (2-player)", new HumanPlayer(), 200);
        addOption("Random (Easy)", new RandomPlayer(), 300);
        addOption("Searcher (Medium)", new SearcherPlayer(), 400);
        addOption("Perfect (Hard)", new PerfectPlayer(), 500);
    }
    
    private void addOption(String descrip, Player player, int y)
    {
        options.put(descrip, player);
        
        addObject(new Button(descrip), getWidth() / 2, y);
    }
    
    public void selected(String text)
    {
        Greenfoot.setWorld(new ProjectileWorld(options.get(text)));
    }
       
}
