import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class SearcherPlayer here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class SearcherPlayer extends ComputerPlayer
{
    private double adjustAmount;
    private double angle;
    private Player tgt = null;
    
    public void startTurn()
    {
        if (tgt == null)
        {
            tgt = pickTarget();
            adjustAmount = 22.5;
            angle = tgt.getX() < getX() ? -135 : -45;
        }
        
        fire(Math.toRadians(angle), 1.0);
    }
    
    public void landed(double x, double y)
    {
        if (x < tgt.getX())
        {
            angle += adjustAmount;
        }
        else
        {
            angle -= adjustAmount;
        }
        
        adjustAmount /= 2;
    }
}
